/*
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either Version 3 of the License, or (at your option) any later
 * version.
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, see <https://www.gnu.org/licenses>.
 * SUPPLEMENTAL TERMS UNDER SECTION 7 OF GNU GENERAL PUBLIC LICENSE
 * The following terms (“Supplemental Terms”) supplement and modify the GNU
 * General Public License, Version 3 applicable to the Program.
 *
 * Copyright © 2014-2022 Arcserve (USA) LLC
 * SPDX-License-Identifier: GPL-2.0+
 */

/* Generic read and write operations to a block device. */
#ifndef STCVSM_BLKRW_H
#define STCVSM_BLKRW_H

#include <linux/blkdev.h>

#include "portability.h"

#ifdef WITH_EXT2BITMAP

#define BLK_BUFF_PAGE 0
#define BLK_BUFF_MEM  1
#define BLK_BUFF_BIO  2

int blk_read(struct block_device *bdev, sector_t sector, void *buffer, unsigned int length,
		atomic_t *numbios, int *bio_error, int buff_type);
void blk_read_wait(atomic_t *numbios);

#endif  /* WITH_EXT2BITMAP */

#endif
